Index: apps/app_directed_pickup.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_directed_pickup.c,v
retrieving revision 1.7
diff -u -r1.7 apps/app_directed_pickup.c
--- apps/app_directed_pickup.c	26 Oct 2005 19:48:14 -0000	1.7
+++ apps/app_directed_pickup.c	2 Nov 2005 01:35:54 -0000
@@ -54,7 +54,7 @@
 	int res = 0;
 	struct localuser *u = NULL;
 	struct ast_channel *origin = NULL, *target = NULL;
-	char *tmp = NULL, *exten = NULL, *context = NULL;
+	char *tmp = NULL, *context = NULL, *rest = data, *exten;
 	char workspace[256] = "";
 
 	if (ast_strlen_zero(data)) {
@@ -64,13 +64,16 @@
 
 	LOCAL_USER_ADD(u);
 	
+       while (!target && (exten = rest)) {
+               res = 0;
+               rest = strchr(exten, '&');
+               if (rest)
+                        *rest++ = 0;
+
 	/* Get the extension and context if present */
-	exten = data;
-	context = strchr(data, '@');
-	if (context) {
-		*context = '\0';
-		context++;
-	}
+	context = strchr(exten, '@');
+	if (context)
+		*context++ = '\0';
 
 	/* Find a channel to pickup */
 	origin = ast_get_channel_by_exten_locked(exten, context);
@@ -81,7 +84,7 @@
 			/* We have a possible channel... now we need to find it! */
 			target = ast_get_channel_by_name_locked(tmp);
 		} else {
-			ast_log(LOG_DEBUG, "No target channel found.\n");
+			ast_log(LOG_NOTICE, "No target channel found for %s.\n", exten);
 			res = -1;
 		}
 		ast_mutex_unlock(&origin->lock);
@@ -90,7 +93,7 @@
 	}
 	
 	if (res)
-		goto out;
+		continue;
 
 	if (target && (!target->pbx) && ((target->_state == AST_STATE_RINGING) || (target->_state == AST_STATE_RING))) {
 		ast_log(LOG_DEBUG, "Call pickup on chan '%s' by '%s'\n", target->name,
@@ -99,27 +102,28 @@
 		if (res) {
 			ast_log(LOG_WARNING, "Unable to answer '%s'\n", chan->name);
 			res = -1;
-			goto out;
+			break;
 		}
 		res = ast_queue_control(chan, AST_CONTROL_ANSWER);
 		if (res) {
 			ast_log(LOG_WARNING, "Unable to queue answer on '%s'\n",
 				chan->name);
 			res = -1;
-			goto out;
+			break;
 		}
 		res = ast_channel_masquerade(target, chan);
 		if (res) {
 			ast_log(LOG_WARNING, "Unable to masquerade '%s' into '%s'\n", chan->name, target->name);
 			res = -1;
-			goto out;
+			break;
 		}
 	} else {
-		ast_log(LOG_DEBUG, "No call pickup possible...\n");
+		ast_log(LOG_NOTICE, "No call pickup possible for %s...\n", exten);
 		res = -1;
 	}
 	/* Done */
- out:
+	}
+
 	if (target) 
 		ast_mutex_unlock(&target->lock);
 	
